## ctfutils 9.2

=== cddl/lib/libctf/Makefile ===
# $FreeBSD$

.PATH:		${.CURDIR}/../../../cddl/contrib/opensolaris/common/ctf
.PATH:		${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libctf/common
.PATH:		${.CURDIR}/../../../sys/cddl/contrib/opensolaris/common/ctf

LIB=		ctf
SRCS=		ctf_create.c \
		ctf_decl.c \
		ctf_error.c \
		ctf_hash.c \
		ctf_labels.c \
		ctf_lib.c \
		ctf_lookup.c \
		ctf_open.c \
		ctf_subr.c \
		ctf_types.c \
		ctf_util.c

WARNS?=		0
CFLAGS+=	-DCTF_OLD_VERSIONS

CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/compat/opensolaris \
		-I${.CURDIR}/../../../cddl/compat/opensolaris/include \
		-I${OPENSOLARIS_USR_DISTDIR}/head \
		-I${OPENSOLARIS_USR_DISTDIR}/common/ctf \
		-I${OPENSOLARIS_USR_DISTDIR}/lib/libctf/common \
		-I${OPENSOLARIS_SYS_DISTDIR}/uts/common

.include <bsd.lib.mk>

=== cddl/usr.bin/ctfconvert/Makefile ===
# $FreeBSD$

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/common
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/cvt

DEBUG_FLAGS=	-g

PROG=		ctfconvert
SRCS=		alist.c \
		ctf.c \
		ctfconvert.c \
		dwarf.c \
		fixup_tdescs.c \
		hash.c \
		iidesc.c \
		input.c \
		list.c \
		memory.c \
		merge.c \
		output.c \
		st_parse.c \
		stabs.c \
		stack.c \
		strtab.c \
		symbol.c \
		tdata.c \
		traverse.c \
		util.c

CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/compat/opensolaris \
		-I${.CURDIR}/../../../cddl/compat/opensolaris/include \
		-I${OPENSOLARIS_USR_DISTDIR} \
		-I${OPENSOLARIS_SYS_DISTDIR} \
		-I${OPENSOLARIS_USR_DISTDIR}/head \
		-I${OPENSOLARIS_USR_DISTDIR}/tools/ctf/common \
		-I${OPENSOLARIS_USR_DISTDIR}/tools/ctf/cvt \
		-I${OPENSOLARIS_SYS_DISTDIR}/uts/common

DPADD=		${LIBCTF} ${LIBDWARF} ${LIBELF} ${LIBZ} ${LIBPTHREAD}
LDADD=		-lctf -ldwarf -lelf -lz -lpthread

.include <bsd.prog.mk>

=== cddl/usr.bin/ctfdump/Makefile ===
# $FreeBSD$

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/common
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/dump

PROG=		ctfdump
SRCS=		dump.c \
		symbol.c \
		utils.c

CFLAGS+=	-I${OPENSOLARIS_USR_DISTDIR} \
		-I${OPENSOLARIS_SYS_DISTDIR} \
		-I${OPENSOLARIS_USR_DISTDIR}/head \
		-I${OPENSOLARIS_USR_DISTDIR}/cmd/mdb/tools/common \
		-I${.CURDIR}/../../../sys/cddl/compat/opensolaris \
		-I${.CURDIR}/../../../cddl/compat/opensolaris/include \
		-I${OPENSOLARIS_USR_DISTDIR}/tools/ctf/common \
		-I${OPENSOLARIS_SYS_DISTDIR}/uts/common

DPADD=		${LIBPTHREAD} ${LIBELF} ${LIBZ}
LDADD=		-lpthread -lelf -lz

.include <bsd.prog.mk>

=== cddl/usr.bin/ctfmerge/Makefile ===
# $FreeBSD$

.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/common
.PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/cvt

PROG=		ctfmerge
SRCS=		alist.c \
		barrier.c \
		ctf.c \
		ctfmerge.c \
		fifo.c \
		hash.c \
		iidesc.c \
		input.c \
		list.c \
		memory.c \
		merge.c \
		output.c \
		strtab.c \
		symbol.c \
		tdata.c \
		traverse.c \
		util.c

WARNS?=		1

CFLAGS+=	-I${.CURDIR}/../../../sys/cddl/compat/opensolaris \
		-I${.CURDIR}/../../../cddl/compat/opensolaris/include \
		-I${OPENSOLARIS_USR_DISTDIR} \
		-I${OPENSOLARIS_SYS_DISTDIR} \
		-I${OPENSOLARIS_USR_DISTDIR}/head \
		-I${OPENSOLARIS_USR_DISTDIR}/tools/ctf/common \
		-I${OPENSOLARIS_USR_DISTDIR}/tools/ctf/cvt \
		-I${OPENSOLARIS_SYS_DISTDIR}/uts/common

DPADD=		${LIBCTF} ${LIBDWARF} ${LIBELF} ${LIBZ} ${LIBPTHREAD}
LDADD=		-lctf -ldwarf -lelf -lz -lpthread

.include <bsd.prog.mk>

=== debian/changelog ===
ctfutils (9.2-5.1) unstable; urgency=low
  
  * Non-maintainer upload.
  [Sphinx Jiang]
   * Fix mips64(el) build: __mips64 and __LP64__ instead of __mips64_n64
     (Closes: #752059).

 -- YunQiang Su <syq@debian.org>  Fri, 10 Oct 2014 13:24:07 +0800

ctfutils (9.2-5) unstable; urgency=low

  * Add -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE to CFLAGS. Thanks
    Aaron M. Ucko. (Closes: #734782)

 -- Robert Millan <rmh@debian.org>  Fri, 10 Jan 2014 00:54:09 +0100

ctfutils (9.2-4) unstable; urgency=low

  * off64_t.diff: Fix off64_t typedef conflict.

 -- Robert Millan <rmh@debian.org>  Wed, 08 Jan 2014 20:57:01 +0100

ctfutils (9.2-3) unstable; urgency=low

  * Bump freebsd-glue requirement to 0.2.16 to fix FTBFS on non-
    kFreeBSD.

 -- Robert Millan <rmh@debian.org>  Wed, 08 Jan 2014 15:17:11 +0100

ctfutils (9.2-2) unstable; urgency=low

  * Set Maintainer to debian-bsd.
  * Fetch source code securely (https) in get-orig-source.
  * Correctly setup BSD version of MAKEFLAGS to support parallel builds.
  * Build-Depend on freebsd-glue >= 0.2.14 (for <sys/elf.h>).

 -- Robert Millan <rmh@debian.org>  Wed, 08 Jan 2014 01:35:18 +0100

ctfutils (9.2-1) unstable; urgency=low

  * Initial release.  (Closes: #729149)

 -- Robert Millan <rmh@debian.org>  Sat, 09 Nov 2013 17:07:06 +0100

=== debian/control ===
Source: ctfutils
Section: devel
Priority: extra
Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
Uploaders: Robert Millan <rmh@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 freebsd-buildutils (>= 9.0-5~),
 libbsd-dev (>= 0.3.0),
 freebsd-glue (>= 0.2.16~),
 libdwarf-freebsd-dev,
 libelf-freebsd-dev,
Vcs-Browser: http://anonscm.debian.org/viewvc/glibc-bsd/trunk/ctfutils/
Vcs-Svn: svn://anonscm.debian.org/glibc-bsd/trunk/ctfutils/
Standards-Version: 3.9.3

Package: ctfutils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: FreeBSD CTF utilities
 This package contains utilities to create, merge and dump contents of
 CTF files.
 .
 CTF (Compact C Type) format encapsulates a reduced form of debugging
 information similar to DWARF.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
SHELL=bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

CFLAGS = -Wall -Wno-unknown-pragmas -g -pipe -fPIC -I. \
         -D_GNU_SOURCE -DNEED_SOLARIS_BOOLEAN \
	-isystem /usr/include/freebsd \
	-Werror=implicit-function-declaration \
	$(NULL)

# Satisfy 64-bit off_t assumptions in the compat layer (see #734782)
CFLAGS += -D_FILE_OFFSET_BITS=64

# Enable fseeko / ftello prototypes, used in the compat layer
CFLAGS += -D_LARGEFILE_SOURCE

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

	# Do not mess with MAKEFLAGS until we transfer control to BSD make (see below)
	BSD_MAKEFLAGS += -j$(NUMJOBS)
endif

full_version	:= $(shell dpkg-parsechangelog | grep ^Version: | sed -e 's/^.*: //g')
tar_version	:= $(shell echo $(full_version) | sed -e 's/-.*//g')
svn_revision	:= $(shell echo $(full_version) | sed -e 's/.*~svn\([0-9]*\)-[0-9]*/\1/g')
version		:= $(shell echo $(full_version) | sed -e 's/[~+-].*//g')
major           := $(shell echo $(version) | sed -e 's/\..*//g')
revision	:= $(shell echo $(full_version) | sed -e 's/^[^+-]*//g')

SVN		:= https://svn0.us-west.freebsd.org/base/release/$(version).0
#SVN		:= https://svn0.us-west.freebsd.org/base/releng/$(version)
#SVN		:= https://svn0.us-west.freebsd.org/base/stable/$(major)
#SVN		:= https://svn0.us-west.freebsd.org/base/head

SOURCE = ctfutils
ORIGDIR = $(SOURCE)-$(tar_version)
TARNAME = $(SOURCE)_$(tar_version).orig.tar.gz

PATH := /usr/lib/freebsd:$(PATH)
DESTDIR = $(CURDIR)/debian/tmp
PMAKE = \
	MAKEFLAGS=$(BSD_MAKEFLAGS) \
	COPTS="$(CFLAGS)" CFLAGS="$(CFLAGS)" NO_WERROR=1 NOGCCERROR=1 \
	OPENSOLARIS_USR_DISTDIR="$(CURDIR)/cddl/contrib/opensolaris" \
	OPENSOLARIS_SYS_DISTDIR="$(CURDIR)/sys/cddl/contrib/opensolaris" \
        NOSHARED=NO NO_SHARED=NO DESTDIR=$(DESTDIR) make
export SHLIB_MAJOR = 0

get-orig-source:
	rm -rf $(ORIGDIR)
	for i in \
		cddl/compat/opensolaris \
		sys/cddl/compat/opensolaris \
		\
		cddl/contrib/opensolaris/common/ctf \
		cddl/contrib/opensolaris/tools/ctf \
		cddl/contrib/opensolaris/lib/libctf \
		cddl/contrib/opensolaris/lib/libgen \
		sys/cddl/contrib/opensolaris/uts/common/ctf \
		sys/cddl/contrib/opensolaris/uts/common/sys \
		\
		cddl/lib/libctf \
		cddl/usr.bin/ctfconvert \
		cddl/usr.bin/ctfdump \
		cddl/usr.bin/ctfmerge \
	         ; do \
	    svn export $(SVN)/$$i $(ORIGDIR)/$$i ; \
	done
	tar --numeric-owner --owner 0 --group 0 -czf ../$(TARNAME) $(ORIGDIR)
	rm -rf $(ORIGDIR)

build: build-arch build-indep

build-arch: build-ctfutils

build-indep:
# We have nothing to do by default.


build-libctf: build-libctf-stamp
build-libctf-stamp:
	$(PMAKE) -C $(CURDIR)/cddl/lib/libctf
	touch $@

build-ctfutils: build-ctfutils-stamp
build-ctfutils-stamp: build-libctf-stamp build-libctf-stamp
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ctfconvert
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ctfdump
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ctfmerge
	touch $@

clean:
	dh_testdir
	dh_testroot
	$(PMAKE) -C $(CURDIR)/cddl/lib/libctf clean
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ctfconvert clean
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ctfdump clean
	$(PMAKE) -C $(CURDIR)/cddl/usr.bin/ctfmerge clean

	rm -f *stamp
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep -s
	dh_installdirs -s
	dh_install -s


binary: binary-arch binary-indep

binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a
	dh_installdocs -a
#	dh_installexamples
	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
#	dh_perl
#	dh_python
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: build clean binary-indep binary-arch binary install configure build-arch build-indep

## ctfutils 10.3~svn297264

=== cddl/lib/libctf/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $FreeBSD$
+# $FreeBSD: releng/10.3/cddl/lib/libctf/Makefile 204597 2010-03-02 19:04:07Z uqs $
 
 .PATH:		${.CURDIR}/../../../cddl/contrib/opensolaris/common/ctf
 .PATH:		${.CURDIR}/../../../cddl/contrib/opensolaris/lib/libctf/common

=== cddl/usr.bin/ctfconvert/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $FreeBSD$
+# $FreeBSD: releng/10.3/cddl/usr.bin/ctfconvert/Makefile 211187 2010-08-11 18:00:45Z rpaulo $
 
 .PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/common
 .PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/cvt

=== cddl/usr.bin/ctfdump/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $FreeBSD$
+# $FreeBSD: releng/10.3/cddl/usr.bin/ctfdump/Makefile 211187 2010-08-11 18:00:45Z rpaulo $
 
 .PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/common
 .PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/dump

=== cddl/usr.bin/ctfmerge/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $FreeBSD$
+# $FreeBSD: releng/10.3/cddl/usr.bin/ctfmerge/Makefile 211187 2010-08-11 18:00:45Z rpaulo $
 
 .PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/common
 .PATH: ${.CURDIR}/../../../cddl/contrib/opensolaris/tools/ctf/cvt

=== debian/changelog ===
ctfutils (10.3~svn297264-2) unstable; urgency=medium

  * Upload to unstable

 -- Steven Chamberlain <steven@pyro.eu.org>  Sat, 28 May 2016 11:49:14 +0100

ctfutils (10.3~svn297264-1) experimental; urgency=medium

  * New upstream snapshot of 10.3-RELEASE
  * Refresh patches:
    - compat_opensolaris.diff
    - ulong_t.diff
  * Make get-orig-source tarball reproducible
  * Use XZ to compress orig source tarball
  * Use new preferred hostname for upstream SVN with HTTPS
    (svn.freebsd.org).
  * Now using Standards-Version 3.9.8 (no changes needed)
  * Turn a "sou %s has too many values" error into a warning;
    encode only the first CTF_MAX_VLEN members.
  * Add myself to Uploaders

 -- Steven Chamberlain <steven@pyro.eu.org>  Sun, 10 Apr 2016 20:58:12 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,8 @@
 Section: devel
 Priority: extra
 Maintainer: GNU/kFreeBSD Maintainers <debian-bsd@lists.debian.org>
-Uploaders: Robert Millan <rmh@debian.org>
+Uploaders: Robert Millan <rmh@debian.org>,
+ Steven Chamberlain <steven@pyro.eu.org>,
 Build-Depends: debhelper (>= 7.0.50~),
  freebsd-buildutils (>= 9.0-5~),
  libbsd-dev (>= 0.3.0),
@@ -11,7 +12,7 @@
  libelf-freebsd-dev,
 Vcs-Browser: http://anonscm.debian.org/viewvc/glibc-bsd/trunk/ctfutils/
 Vcs-Svn: svn://anonscm.debian.org/glibc-bsd/trunk/ctfutils/
-Standards-Version: 3.9.3
+Standards-Version: 3.9.8
 
 Package: ctfutils
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -41,16 +41,18 @@
 major           := $(shell echo $(version) | sed -e 's/\..*//g')
 revision	:= $(shell echo $(full_version) | sed -e 's/^[^+-]*//g')
 
-SVN		:= https://svn0.us-west.freebsd.org/base/release/$(version).0
-#SVN		:= https://svn0.us-west.freebsd.org/base/releng/$(version)
-#SVN		:= https://svn0.us-west.freebsd.org/base/stable/$(major)
-#SVN		:= https://svn0.us-west.freebsd.org/base/head
+SVN_BASE	:= https://svn.freebsd.org/base
+#SVN		:= $(SVN_BASE)/release/$(version).0
+SVN		:= $(SVN_BASE)/releng/$(version)
+#SVN		:= $(SVN_BASE)/stable/$(major)
+#SVN		:= $(SVN_BASE)/head
 
 SOURCE = ctfutils
-ORIGDIR = $(SOURCE)-$(tar_version)
-TARNAME = $(SOURCE)_$(tar_version).orig.tar.gz
+ORIG_DIR = $(SOURCE)-$(tar_version)
+ORIG_TAR = $(SOURCE)_$(tar_version).orig.tar.xz
 
 PATH := /usr/lib/freebsd:$(PATH)
+SOURCE_DATE_EPOCH ?= $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)
 DESTDIR = $(CURDIR)/debian/tmp
 PMAKE = \
 	MAKEFLAGS=$(BSD_MAKEFLAGS) \
@@ -61,7 +63,7 @@
 export SHLIB_MAJOR = 0
 
 get-orig-source:
-	rm -rf $(ORIGDIR)
+	rm -rf $(ORIG_DIR)
 	for i in \
 		cddl/compat/opensolaris \
 		sys/cddl/compat/opensolaris \
@@ -78,10 +80,19 @@
 		cddl/usr.bin/ctfdump \
 		cddl/usr.bin/ctfmerge \
 	         ; do \
-	    svn export $(SVN)/$$i $(ORIGDIR)/$$i ; \
+	    svn export $(SVN)/$$i $(ORIG_DIR)/$$i || exit ; \
 	done
-	tar --numeric-owner --owner 0 --group 0 -czf ../$(TARNAME) $(ORIGDIR)
-	rm -rf $(ORIGDIR)
+	# Clamp timestamps to be no newer than last changelog entry, see
+	# https://wiki.debian.org/ReproducibleBuilds/TimestampsInTarball
+	find $(ORIG_DIR) -newermt "@$(SOURCE_DATE_EPOCH)" -print0 \
+	 | xargs -0r touch --no-dereference --date="@$(SOURCE_DATE_EPOCH)"
+	# Create tarball with files sorted in a stable order, see
+	# https://wiki.debian.org/ReproducibleBuilds/FileOrderInTarballs
+	find $(ORIG_DIR) -print0 | LC_ALL=C sort -z \
+	 | tar --null --no-recursion --files-from - \
+	    --numeric-owner --owner 0 --group 0 \
+	    -cJf ../$(ORIG_TAR)
+	rm -rf $(ORIG_DIR)
 
 build: build-arch build-indep
